---
title: 'WebGLRenderingContext.texParameter[fi]()'
slug: Web/API/WebGLRenderingContext/texParameter
tags:
  - API
  - Method
  - Reference
  - Textures
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.texParameter[fi]()</code></strong> methods of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> set texture parameters.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">void <var>gl</var>.texParameterf(GLenum <var>target</var>, GLenum <var>pname</var>, GLfloat <var>param</var>);
void <var>gl</var>.texParameteri(GLenum <var>target</var>, GLenum <var>pname</var>, GLint <var>param</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>target</dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target). Possible values:
 <ul>
  <li><code>gl.TEXTURE_2D</code>: A two-dimensional texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP</code>: A cube-mapped texture.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.TEXTURE_3D</code>: A three-dimensional texture.</li>
    <li><code>gl.TEXTURE_2D_ARRAY</code>: A two-dimensional array texture.</li>
   </ul>
  </li>
 </ul>
 </dd>
</dl>

<p>The <code>pname</code> parameter is a {{domxref("Glenum")}} specifying the texture parameter to set. The <code>param</code> parameter is a {{domxref("GLfloat")}} or {{domxref("GLint")}} specifying the value for the specified parameter <code>pname</code>.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col"><code>pname</code></th>
   <th scope="col">Description</th>
   <th scope="col"><code>param</code></th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th colspan="3">Available in WebGL 1</th>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_MAG_FILTER</code></td>
   <td>Texture magnification filter</td>
   <td><code>gl.LINEAR</code> (default value), <code>gl.NEAREST</code>.</td>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_MIN_FILTER</code></td>
   <td>Texture minification filter</td>
   <td><code>gl.LINEAR</code>, <code>gl.NEAREST</code>, <code>gl.NEAREST_MIPMAP_NEAREST</code>, <code>gl.LINEAR_MIPMAP_NEAREST</code>, <code>gl.NEAREST_MIPMAP_LINEAR</code> (default value), <code>gl.LINEAR_MIPMAP_LINEAR</code>.</td>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_WRAP_S</code></td>
   <td>Wrapping function for texture coordinate <code>s</code></td>
   <td><code>gl.REPEAT</code> (default value),<code>gl.CLAMP_TO_EDGE</code>, <code>gl.MIRRORED_REPEAT</code>.</td>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_WRAP_T</code></td>
   <td>Wrapping function for texture coordinate <code>t</code></td>
   <td><code>gl.REPEAT</code> (default value),<code>gl.CLAMP_TO_EDGE</code>, <code>gl.MIRRORED_REPEAT</code>.</td>
  </tr>
  <tr>
   <th colspan="3">Additionally available when using the {{domxref("EXT_texture_filter_anisotropic")}} extension</th>
  </tr>
  <tr>
   <td><code>ext.TEXTURE_MAX_ANISOTROPY_EXT</code></td>
   <td>Maximum anisotropy for a texture</td>
   <td>A {{domxref("GLfloat")}} value.</td>
  </tr>
  <tr>
   <th colspan="3">Additionally available when using a WebGL 2 context</th>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_BASE_LEVEL</code></td>
   <td>Texture mipmap level</td>
   <td>Any int values.</td>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_COMPARE_FUNC</code></td>
   <td>Texture Comparison function</td>
   <td><code>gl.LEQUAL</code> (default value), <code>gl.GEQUAL</code>, <code>gl.LESS</code>, <code>gl.GREATER</code>, <code>gl.EQUAL</code>, <code>gl.NOTEQUAL</code>, <code>gl.ALWAYS</code>, <code>gl.NEVER</code>.</td>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_COMPARE_MODE</code></td>
   <td>Texture comparison mode</td>
   <td><code>gl.NONE</code> (default value), <code>gl.COMPARE_REF_TO_TEXTURE</code>.</td>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_MAX_LEVEL</code></td>
   <td>Maximum texture mipmap array level</td>
   <td>Any int values.</td>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_MAX_LOD</code></td>
   <td>Texture maximum level-of-detail value</td>
   <td>Any float values.</td>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_MIN_LOD</code></td>
   <td>Texture minimum level-of-detail value</td>
   <td>Any float values.</td>
  </tr>
  <tr>
   <td><code>gl.TEXTURE_WRAP_R</code></td>
   <td>Wrapping function for texture coordinate <code>r</code></td>
   <td><code>gl.REPEAT</code> (default value), <code>gl.CLAMP_TO_EDGE</code>, <code>gl.MIRRORED_REPEAT</code>.</td>
  </tr>
 </tbody>
</table>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">gl.texParameterf(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR_MIPMAP_NEAREST);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.8", "texParameter[fi]")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glTexParameter.xml", "glTexParameter")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 2.0 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.6", "texParameter[fi]")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Updated definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glTexParameter.xhtml", "glTexParameter")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3.0 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<h3 id="WebGLRenderingContext.texParameterf"><code>WebGLRenderingContext.texParameterf()</code></h3>

<p>{{Compat("api.WebGLRenderingContext.texParameterf")}}</p>

<h3 id="WebGLRenderingContext.texParameteri"><code>WebGLRenderingContext.texParameteri()</code></h3>

<p>{{Compat("api.WebGLRenderingContext.texParameteri")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getTexParameter()")}}</li>
 <li>{{domxref("EXT_texture_filter_anisotropic")}}</li>
</ul>
